/* --COPYRIGHT--,BSD
 * Copyright (c) 2016, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

/*******************************************************************************
 *
 *  drv87xxx_drv8106x-q1.h - Declaration file for utility functions and global variables
 *  drv87xxx_drv8106x-q1_EVM_FIRMWARE
 *
 ******************************************************************************/
#include "../../dataTypeDefinition.h"

/*******************************************************************************
 * MACROS
 *******************************************************************************/

/*************************************************************
 * drv87xxs_drv8106s-q1 SPI Register ADDRESS
 *************************************************************/

//drv870xs-q1_drv8106s-q1
#define IC_STAT_1                    (uint8_t)(0x00)
#define VGS_VDS_STAT                 (uint8_t)(0x01)
#define IC_STAT_2                    (uint8_t)(0x02)
#define RSVD_STAT                    (uint8_t)(0x03)
#define IC_CTRL                      (uint8_t)(0x04)
#define BRG_CTRL                     (uint8_t)(0x05)
#define DRV_CTRL_1                   (uint8_t)(0x06)
#define DRV_CTRL_2                   (uint8_t)(0x07)
#define DRV_CTRL_3                   (uint8_t)(0x08)
#define VDS_CTRL_1                   (uint8_t)(0x09)
#define VDS_CTRL_2                   (uint8_t)(0x0A)
#define OLSC_CTRL                    (uint8_t)(0x0B)
#define UVOV_CTRL                    (uint8_t)(0x0C)
#define CSA_CTRL                     (uint8_t)(0x0D)

//drv87xxs-q1
#define IC_STAT_1_DRV871XX                    (uint8_t)(0x00)
#define VDS_STAT1_DRV871XX                    (uint8_t)(0x01)
#define VDS_STAT2_DRV871XX                    (uint8_t)(0x02)
#define VGS_STAT1_DRV871XX                    (uint8_t)(0x03)
#define VGS_STAT2_DRV871XX                    (uint8_t)(0x04)
#define IC_STAT2_DRV871XX                     (uint8_t)(0x05)
#define IC_STAT3_DRV871XX                     (uint8_t)(0x06)

#define IC_CTRL1_DRV871XX                     (uint8_t)(0x07)
#define IC_CTRL2_DRV871XX                     (uint8_t)(0x08)

#define BRG_CTRL1_DRV871XX                    (uint8_t)(0x09)
#define BRG_CTRL2_DRV871XX                    (uint8_t)(0x0A)

#define PWM_CTRL1_DRV871XX                    (uint8_t)(0x0B)
#define PWM_CTRL2_DRV871XX                    (uint8_t)(0x0C)
#define PWM_CTRL3_DRV871XX                    (uint8_t)(0x0D)
#define PWM_CTRL4_DRV871XX                    (uint8_t)(0x0E)

#define IDRV_CTRL1_DRV871XX                   (uint8_t)(0x0F)
#define IDRV_CTRL2_DRV871XX                   (uint8_t)(0x10)
#define IDRV_CTRL3_DRV871XX                   (uint8_t)(0x11)
#define IDRV_CTRL4_DRV871XX                   (uint8_t)(0x12)
#define IDRV_CTRL5_DRV871XX                   (uint8_t)(0x13)
#define IDRV_CTRL6_DRV871XX                   (uint8_t)(0x14)
#define IDRV_CTRL7_DRV871XX                   (uint8_t)(0x15)
#define IDRV_CTRL8_DRV871XX                   (uint8_t)(0x16)
#define IDRV_CTRL9_DRV871XX                   (uint8_t)(0x17)

#define DRV_CTRL1_DRV871XX                    (uint8_t)(0x18)
#define DRV_CTRL2_DRV871XX                    (uint8_t)(0x19)
#define DRV_CTRL3_DRV871XX                    (uint8_t)(0x1A)
#define DRV_CTRL4_DRV871XX                    (uint8_t)(0x1B)
#define DRV_CTRL5_DRV871XX                    (uint8_t)(0x1C)
#define DRV_CTRL6_DRV871XX                    (uint8_t)(0x1D)
#define DRV_CTRL7_DRV871XX                    (uint8_t)(0x1E)

#define VDS_CTRL1_DRV871XX                    (uint8_t)(0x1F)
#define VDS_CTRL2_DRV871XX                    (uint8_t)(0x20)
#define VDS_CTRL3_DRV871XX                    (uint8_t)(0x21)
#define VDS_CTRL4_DRV871XX                    (uint8_t)(0x22)

#define OLSC_CTRL1_DRV871XX                   (uint8_t)(0x23)
#define OLSC_CTRL2_DRV871XX                   (uint8_t)(0x24)

#define UVOV_CTRL_DRV871XX                    (uint8_t)(0x25)

#define CSA_CTRL1_DRV871XX                    (uint8_t)(0x26)
#define CSA_CTRL2_DRV871XX                    (uint8_t)(0x27)
#define CSA_CTRL3_DRV871XX                    (uint8_t)(0x28)

#define AGD_CTRL1_DRV871XX                    (uint8_t)(0x2A)

#define PDR_CTRL1_DRV871XX                    (uint8_t)(0x2B)
#define PDR_CTRL2_DRV871XX                    (uint8_t)(0x2C)
#define PDR_CTRL3_DRV871XX                    (uint8_t)(0x2D)
#define PDR_CTRL4_DRV871XX                    (uint8_t)(0x2E)
#define PDR_CTRL5_DRV871XX                    (uint8_t)(0x2F)
#define PDR_CTRL6_DRV871XX                    (uint8_t)(0x30)
#define PDR_CTRL7_DRV871XX                    (uint8_t)(0x31)
#define PDR_CTRL8_DRV871XX                    (uint8_t)(0x32)
#define PDR_CTRL9_DRV871XX                    (uint8_t)(0x33)
#define PDR_CTRL10_DRV871XX                   (uint8_t)(0x34)

#define STC_CTRL1_DRV871XX                    (uint8_t)(0x35)
#define STC_CTRL2_DRV871XX                    (uint8_t)(0x36)
#define STC_CTRL3_DRV871XX                    (uint8_t)(0x37)
#define STC_CTRL4_DRV871XX                    (uint8_t)(0x38)

#define DCC_CTRL1_DRV871XX                    (uint8_t)(0x39)

#define PST_CTRL1_DRV871XX                    (uint8_t)(0x3A)
#define PST_CTRL2_DRV871XX                    (uint8_t)(0x3B)

#define SGD_STAT1_DRV871XX                    (uint8_t)(0x3C)
#define SGD_STAT2_DRV871XX                    (uint8_t)(0x3D)
#define SGD_STAT3_DRV871XX                    (uint8_t)(0x3E)

#define CLR_FLT_MASK            (0x01)        /*Clear all fault bits*/

#define WD_FLT_SHIFT            2
#define WD_FLT_MASK             (0x1 << WD_FLT_SHIFT)

#define WD_EN_SHIFT             3
#define WD_EN_MASK              (0x1 << WD_EN_SHIFT)

#define WD_FLT_M_SHIFT          2
#define WD_FLT_M_MASK           (0x1 << WD_FLT_M_SHIFT)

#define WD_WIN_SHIFT            1
#define WD_WIN_MASK             (0x1 << WD_WIN_SHIFT)

#define WD_RST_SHIFT            0
#define WD_RST_MASK            (0x1 << WD_RST_SHIFT)


/*******************************************************************************
 * Structure
 *******************************************************************************/

/**
 *  Structure initializing the Registers
 */
typedef struct DRV8x06_REG
{
    //drv870xs-q1_drv8106s-q1
    uint8_t ic_status_1_reg;
    uint8_t vgs_vds_stat_reg;
    uint8_t ic_status_2_reg;
    uint8_t rsvd_stat_reg;

    uint8_t ic_ctrl_reg;

    uint8_t brg_ctrl_reg;

    uint8_t drv_ctrl_1_reg;
    uint8_t drv_ctrl_2_reg;
    uint8_t drv_ctrl_3_reg;

    uint8_t vds_ctrl_1_reg;
    uint8_t vds_ctrl_2_reg;

    uint8_t olsc_ctrl_reg;

    uint8_t uvov_ctrl_reg;

    uint8_t csa_ctrl_reg;


    //drv871xxs-Q1
    uint8_t ic_stat1_reg;

    uint8_t vds_stat1_reg;
    uint8_t vds_stat2_reg;

    uint8_t vgs_stat1_reg;
    uint8_t vgs_stat2_reg;

    uint8_t ic_stat2_reg;
    uint8_t ic_stat3_reg;

    uint8_t ic_ctrl1_reg;
    uint8_t ic_ctrl2_reg;

    uint8_t brg_ctrl1_reg;
    uint8_t brg_ctrl2_reg;

    uint8_t pwm_ctrl1_reg;
    uint8_t pwm_ctrl2_reg;
    uint8_t pwm_ctrl3_reg;
    uint8_t pwm_ctrl4_reg;

    uint8_t idrv_ctrl1_reg;
    uint8_t idrv_ctrl2_reg;
    uint8_t idrv_ctrl3_reg;
    uint8_t idrv_ctrl4_reg;
    uint8_t idrv_ctrl5_reg;
    uint8_t idrv_ctrl6_reg;
    uint8_t idrv_ctrl7_reg;
    uint8_t idrv_ctrl8_reg;
    uint8_t idrv_ctrl9_reg;

    uint8_t drv_ctrl1_reg;
    uint8_t drv_ctrl2_reg;
    uint8_t drv_ctrl3_reg;
    uint8_t drv_ctrl4_reg;
    uint8_t drv_ctrl5_reg;
    uint8_t drv_ctrl6_reg;
    uint8_t drv_ctrl7_reg;

    uint8_t vds_ctrl1_reg;
    uint8_t vds_ctrl2_reg;
    uint8_t vds_ctrl3_reg;
    uint8_t vds_ctrl4_reg;

    uint8_t olsc_ctrl1_reg;
    uint8_t olsc_ctrl2_reg;

//    uint8_t uvov_ctrl_reg;                   // already defined in drv870xs-q1_drv8106s-q1

    uint8_t csa_ctrl1_reg;
    uint8_t csa_ctrl2_reg;
    uint8_t csa_ctrl3_reg;

    uint8_t agd_ctrl1_reg;

    uint8_t pdr_ctrl1_reg;
    uint8_t pdr_ctrl2_reg;
    uint8_t pdr_ctrl3_reg;
    uint8_t pdr_ctrl4_reg;
    uint8_t pdr_ctrl5_reg;
    uint8_t pdr_ctrl6_reg;
    uint8_t pdr_ctrl7_reg;
    uint8_t pdr_ctrl8_reg;
    uint8_t pdr_ctrl9_reg;
    uint8_t pdr_ctrl10_reg;

    uint8_t stc_ctrl1_reg;
    uint8_t stc_ctrl2_reg;
    uint8_t stc_ctrl3_reg;
    uint8_t stc_ctrl4_reg;

    uint8_t dcc_ctrl1_reg;

    uint8_t pst_ctrl1_reg;
    uint8_t pst_ctrl2_reg;

    uint8_t sgd_stat1_reg;
    uint8_t sgd_stat2_reg;
    uint8_t sgd_stat3_reg;
} DRV8x06_Q1_REG_t;
